Index: trunk/NEMOGCM/TOOLS/GRIDGEN/src/mixed_grid.f90
===================================================================
--- trunk/NEMOGCM/TOOLS/GRIDGEN/src/mixed_grid.f90	(revision 2528)
+++ trunk/NEMOGCM/TOOLS/GRIDGEN/src/mixed_grid.f90	(revision 2528)
@@ -0,0 +1,267 @@
+MODULE mixed_grid
+!!-----------------------------------------------------------
+!!
+!!       tools box to create a mixed grid storing 
+!!           the known values of grids U,V,T,F
+!!
+!!	        Created by Brice Lemaire on 01/2010.
+!!
+!!-----------------------------------------------------------
+  USE readwrite
+  !
+  IMPLICIT NONE
+  PUBLIC
+  !
+  CONTAINS
+  !********************************************************
+  !            SUBROUTINE define_mixed_grid             *
+  !												        *
+  !         to define the size of the mixed grid        *
+  !														*
+  !            CALL from create_coordinates             *
+  !********************************************************
+  SUBROUTINE define_mixed_grid
+    !
+    INTEGER :: ixgmix, iygmix
+    INTEGER :: ii, ij
+    ! 
+	WRITE(*,*) ''
+	WRITE(*,*) ' ### SUBROUTINE define_mixed_grid ### '
+	WRITE(*,*) ''
+	!
+	WRITE(*,*) ' *** CHECKING SIZE OF COARSE DOMAIN *** '
+	WRITE(*,*) nxcoag, 'x', nycoag
+	WRITE(*,*) ''
+	!
+    !*************************************
+	!!!Calculate size of mixed grid (ixgmix x iygmix)
+    !*************************************
+	IF(.NOT.nglobal) THEN
+	  ixgmix = (nxcoag) * 2                              !known points (T,U,V,F) along x
+	  ixgmix = ixgmix + (nn_rhox-1)*(ixgmix)!-1)           !points to interpolate    ''
+	  ! 
+	  iygmix = (nycoag) * 2                              !known points (T,U,V,F) along y
+	  iygmix = iygmix + (nn_rhoy-1)*(iygmix)!-1)           !points to interpolate    ''
+	ELSEIF(nglobal) THEN
+	  ixgmix = (nxcoag) * 2                             
+	  ixgmix = ixgmix + (nn_rhox-1)*(ixgmix)              
+	  ! 
+	  iygmix = (nycoag) * 2                            
+	  iygmix = iygmix + (nn_rhoy-1)*(iygmix)     
+	ENDIF
+	!
+	nxgmix = ixgmix
+	nygmix = iygmix
+	!
+	WRITE(*,*) ''
+	WRITE(*,*) '*** SIZE OF MIXED GRID ***'
+	WRITE(*,*) nxgmix, ' x ', nygmix
+	WRITE(*,*) ''
+    !
+    CALL mixed_grid_allocate(smixgrd,ixgmix,iygmix)     !using type.f90
+    !
+	IF(nglobal)THEN
+	  ii = 1
+      ij = 1
+    ELSE
+	  ii = nn_imin-1
+	  ij = nn_jmin-1
+	ENDIF
+	!
+    CALL write_mixed_grid(ixgmix,iygmix,ii,ij)   
+    !
+	WRITE(*,*) ''
+	WRITE(*,*) ' ### END SUBROUTINE define_mixed_grid ### '
+	WRITE(*,*) ''  
+	!
+  END SUBROUTINE
+  !
+  !
+  !
+  !********************************************************
+  !           SUBROUTINE write_mixed_grid   			  *
+  !									        			  *
+  !  to write the known values into the mixed grid		  *
+  !	These known values are spaced every (nn_rho-1) points *
+  !	    for allowing to compute the interpolation         *
+  !               inside this same grid	     			  *
+  !														  *
+  !******************************************************** 
+  SUBROUTINE write_mixed_grid(ki_end,kj_end,ki_min,kj_min)
+    !
+	INTEGER, INTENT(IN) :: ki_end, kj_end
+	INTEGER, INTENT(INOUT) :: ki_min, kj_min
+	INTEGER :: ji_start, jj_start
+	INTEGER :: ji,jj
+	INTEGER :: isym_x, isym_y
+	INTEGER :: itmp1, itmp2, itmp3, itmp4, itmp5, itmp6, itmp7
+    INTEGER :: icorrxt, icorrxu, icorrxv, icorrxf      !correction factor for i-indexation
+    INTEGER :: icorryt, icorryu, icorryv, icorryf      !correction factor for j-indexation
+	LOGICAL :: llp = .TRUE.
+	LOGICAL :: llq = .TRUE.
+	!
+	WRITE(*,*) ''
+	WRITE(*,*) ' ### SUBROUTINE write_mixed_grid ### '
+	WRITE(*,*) '' 
+	!
+	ji_start = 1
+	jj_start = 1   
+    !
+	isym_y = 1
+	!
+	! correction factor for symmetry along north boundary
+	icorrxt = 0
+	icorrxu = 0
+	icorrxv = 0
+	icorrxf = 0
+    !
+	icorryt = 0
+	icorryu = 0
+	icorryv = 0
+	icorryf = 0
+	!
+	DO jj=nn_rhoy,kj_end,2*nn_rhoy
+      !
+	  DO ji=nn_rhox,ki_end,2*nn_rhox
+        !
+		smixgrd%nav_lon(ji,jj)              =  scoagrd%nav_lon(ki_min + icorrxt, kj_min + icorryt)
+		smixgrd%nav_lat(ji,jj)              =  scoagrd%nav_lat(ki_min + icorrxt, kj_min + icorryt)	    
+		!
+		smixgrd%glam(ji,jj)                 =  scoagrd%glamt(ki_min + icorrxt, kj_min + icorryt)
+		smixgrd%glam(ji+nn_rhox,jj)         =  scoagrd%glamu(ki_min + icorrxu, kj_min + icorryu)
+		smixgrd%glam(ji,jj+nn_rhoy)         =  scoagrd%glamv(ki_min + icorrxv, kj_min + icorryv)
+		smixgrd%glam(ji+nn_rhox,jj+nn_rhoy) =  scoagrd%glamf(ki_min + icorrxf, kj_min + icorryf)		    
+		!
+		smixgrd%gphi(ji,jj)                 =  scoagrd%gphit(ki_min + icorrxt, kj_min + icorryt)
+		smixgrd%gphi(ji+nn_rhox,jj)         =  scoagrd%gphiu(ki_min + icorrxu, kj_min + icorryu)		 
+		smixgrd%gphi(ji,jj+nn_rhoy)         =  scoagrd%gphiv(ki_min + icorrxv, kj_min + icorryv)
+		smixgrd%gphi(ji+nn_rhox,jj+nn_rhoy) =  scoagrd%gphif(ki_min + icorrxf, kj_min + icorryf)
+		!
+		smixgrd%e1(ji,jj)                   =  scoagrd%e1t(ki_min + icorrxt, kj_min + icorryt)
+		smixgrd%e1(ji+nn_rhox,jj)           =  scoagrd%e1u(ki_min + icorrxu, kj_min + icorryu)		 
+		smixgrd%e1(ji,jj+nn_rhoy)           =  scoagrd%e1v(ki_min + icorrxv, kj_min + icorryv)
+		smixgrd%e1(ji+nn_rhox,jj+nn_rhoy)   =  scoagrd%e1f(ki_min + icorrxf, kj_min + icorryf)	
+		!	
+		smixgrd%e2(ji,jj)                   =  scoagrd%e2t(ki_min + icorrxt, kj_min + icorryt)
+		smixgrd%e2(ji+nn_rhox,jj)           =  scoagrd%e2u(ki_min + icorrxu, kj_min + icorryu)		 
+		smixgrd%e2(ji,jj+nn_rhoy)           =  scoagrd%e2v(ki_min + icorrxv, kj_min + icorryv)
+		smixgrd%e2(ji+nn_rhox,jj+nn_rhoy)   =  scoagrd%e2f(ki_min + icorrxf, kj_min + icorryf)
+        !
+		IF(.NOT.nglobal)THEN
+		  IF(ki_min.EQ.nsizex.AND.nn_imin.NE.2) THEN          ! across right/left boundary BUT not all around the earth
+			ki_min = 3
+		  ELSEIF(isym_y.EQ.1) THEN                            ! normal case
+			ki_min = ki_min + 1                                
+		  ELSEIF(isym_y.EQ.-1) THEN                           ! symetry along north boundary
+			ki_min = ki_min - 1              
+		  ENDIF
+		ELSE
+		  ki_min = ki_min + 1
+		ENDIF
+        !
+	  ENDDO
+      !	 
+	  !
+	  ! when we reach north boundary
+	  IF(.NOT.nglobal)THEN
+		IF(kj_min.EQ.nsizey-npivot-1.AND.llp) THEN           ! npivot => pivot located on T-point or F-point
+		  llp = .FALSE.
+		  kj_min = nsizey 
+		  isym_y = -1
+		  IF(nn_imin.LT.nmid.AND.nn_imax.LT.nmid) THEN       ! no bipole (from Asia to Canada)                               
+			itmp1 = nsizex - nn_imin + 2 + npivot              
+			isym_x = 1
+		  ELSEIF(nn_imin.GT.nmid.AND.nn_imax.GT.nmid) THEN   ! no bipole (from Canada to Asia)
+			itmp2 = nsizex - nn_imin + 2 + npivot               		  
+			isym_x = 2
+		  ELSEIF(nn_imin.LT.nmid.AND.nn_imax.GT.nmid) THEN   ! canadian bipole
+			IF(nval1.LT.nval2) THEN
+			  itmp3 = nmid + nval2 
+			  isym_x = 3
+			ELSEIF(nval1.GE.nval2) THEN                      ! canadian bipole
+			  itmp4 = nmid + nval1 + 2 - npivot
+			  isym_x = 4
+			ENDIF
+		  ELSEIF(ki_min.EQ.nsizex.AND.nval1.GT.nval2) THEN   ! asian bipole
+			  itmp5 = nval1 + 1 + npivot
+			  isym_x = 5
+		  ELSEIF(ki_min.EQ.nsizex.AND.nval1.LT.nval2) THEN   ! asian bipole
+			  itmp6 = nval2 + 1
+			  isym_x = 6		
+		  ELSEIF(ki_min.GE.nmid) THEN                        ! all around the earth (2 bipoles)
+			  itmp7 = nsizex 
+			  isym_x = 7
+		  ENDIF
+		ENDIF
+	    !
+	    !
+	    !
+	    IF(isym_y.EQ.1) THEN
+          kj_min = kj_min + 1                   ! cas normal
+          ki_min = nn_imin - 1   
+	    ELSEIF(isym_y.EQ.-1) THEN                             
+		  kj_min = kj_min - 1  
+		  !
+		  icorrxt = 0   
+		  icorrxu = -1  
+		  icorrxv = 0   
+		  icorrxf = -1  
+		  !
+		  icorryt = 0   
+		  icorryu = 0    
+		  icorryv = -1  
+		  icorryf = -1  
+		  !      		
+		  IF(isym_x.EQ.1) THEN                  ! no bipole
+			ki_min = itmp1
+			IF(llq)THEN
+			  icorrxt = 0   
+			  icorrxu = -1 + npivot
+			  icorrxv = 0   
+			  !
+			  icorryt = 0   
+			  icorryu = 0    
+			  icorryv = -1 + npivot 
+			  !  
+			  llq = .FALSE.
+			ENDIF		
+          ELSEIF(isym_x.EQ.2) THEN              ! no bipole
+		    ki_min = itmp2 
+	      ELSEIF(isym_x.EQ.3) THEN              ! canadian bipole
+		    ki_min = itmp3	
+	      ELSEIF(isym_x.EQ.4) THEN              ! canadian bipole
+		    ki_min = itmp4 
+		    IF(llq)THEN
+			  icorrxt = 0   
+			  icorrxu = -1 + npivot
+			  icorrxv = 0   
+			  !
+			  icorryt = 0   
+			  icorryu = 0    
+			  icorryv = -1 + npivot 
+			  !  
+			  llq = .FALSE.
+		    ENDIF	
+		  ELSEIF(isym_x.EQ.5) THEN              ! asian bipole
+		    ki_min = itmp5		    
+	      ELSEIF(isym_x.EQ.6) THEN              ! asian bipole
+		    ki_min = itmp6      
+		  ELSEIF(isym_x.EQ.7) THEN              ! all around the earth (2 bipoles)
+		    ki_min = itmp7	
+		  ENDIF
+		  !
+	    ENDIF
+		!
+	  ELSEIF(nglobal) THEN
+        kj_min = kj_min + 1                    
+	    ki_min = 1 	  
+	  ENDIF
+	ENDDO
+	!
+	WRITE(*,*) ''
+	WRITE(*,*) ' ### END SUBROUTINE write_mixed_grid ### '
+	WRITE(*,*) ''   
+	! 
+  END SUBROUTINE
+  !
+END MODULE
Index: trunk/NEMOGCM/TOOLS/GRIDGEN/src/projection.f90
===================================================================
--- trunk/NEMOGCM/TOOLS/GRIDGEN/src/projection.f90	(revision 2528)
+++ trunk/NEMOGCM/TOOLS/GRIDGEN/src/projection.f90	(revision 2528)
@@ -0,0 +1,240 @@
+MODULE projection
+!!-----------------------------------------------------------
+!!
+!!          to make a polar stereographic projection 
+!!              in the area of the north pole
+!!
+!!	         Created by Brice Lemaire on 05/2010.
+!!
+!!-----------------------------------------------------------
+  USE readwrite
+  !
+  IMPLICIT NONE
+  PUBLIC
+  !
+  REAL*8,DIMENSION(4) :: dmixlam, dmixphi
+  REAL*8 :: dray = 6357          !rayon polaire de la Terre (km)    
+  REAL*8 :: PI = ACOS(-1.0)
+  REAL*8 :: dlong0 = 0.          !longitude du centre de projection (origine)
+  REAL*8 :: dlat0 = 90.          !latitude       ''    
+  INTEGER :: idisc = 0           !to check the +/- 180 discontinuity
+  INTEGER :: m
+  !
+  CONTAINS  
+  !********************************************************
+  !            SUBROUTINE stereo_projection      	    *
+  !									        			*
+  !												        *
+  !		          CALLED by cfg_tools.F90	            *
+  !********************************************************
+  SUBROUTINE stereo_projection(kji,kjj,kjk,knorth_pole,kway)
+    !
+    INTEGER,INTENT(IN) :: kji,kjj,kjk
+	LOGICAL,INTENT(IN) :: knorth_pole
+	INTEGER,INTENT(IN) :: kway
+	INTEGER :: klon, klat
+	REAL*8,DIMENSION(4) :: dlx, dly
+	REAL*8,DIMENSION(4) :: dllam, dlphi, dlk
+	REAL*8 :: dl_lat0, dl_long0
+	!
+    dl_lat0 = dlat0 * PI/180.
+    dl_long0 = dlong0 * PI/180.
+    !
+	!Either we interpolate along longitude or along latitude
+	IF(kway.EQ.1)THEN
+	  klon = 1
+	  klat = 0
+	ELSEIF(kway.EQ.2) THEN
+	  klon = 0
+	  klat = 1
+	ENDIF
+	!
+	! Check the discontinuity +/- 180
+	IF(kway.EQ.1)THEN
+	  IF(smixgrd%glam(kji,kjj).LT.180..AND.smixgrd%glam(kji+3*nn_rhox,kjj).GT.180.) THEN
+	    IF(smixgrd%glam(kji+2*nn_rhox,kjj).LT.180.) THEN
+	      idisc = 1
+	    ELSEIF(smixgrd%glam(kji+1*nn_rhox,kjj).GT.180.) THEN 
+	      idisc = 2
+        ELSEIF(smixgrd%glam(kji+2*nn_rhox,kjj).GT.180.AND.smixgrd%glam(kji+1*nn_rhox,kjj).LT.180.)THEN
+	      idisc = 3
+	    ENDIF
+	  ELSE
+	  idisc = 0
+	  ENDIF
+	ENDIF
+	!
+	dllam(1) = smixgrd%glam(kji,kjj) * PI/180.
+	dlphi(1) = smixgrd%gphi(kji,kjj) * PI/180.
+	dlk(1)   = (2*dray) / (1 + (SIN(dl_lat0)*SIN(dlphi(1))) + (COS(dl_lat0)*COS(dlphi(1))*COS(dllam(1) - dl_long0)))
+	!
+	dllam(2) = smixgrd%glam(kji+1*nn_rhox*klon,kjj+1*nn_rhoy*klat) * PI/180.
+	dlphi(2) = smixgrd%gphi(kji+1*nn_rhox*klon,kjj+1*nn_rhoy*klat) * PI/180.
+	dlk(2)   = (2*dray) / (1 + (SIN(dl_lat0)*SIN(dlphi(2))) + (COS(dl_lat0)*COS(dlphi(2))*COS(dllam(2) - dl_long0)))
+	!
+	dllam(3) = smixgrd%glam(kji+2*nn_rhox*klon,kjj+2*nn_rhoy*klat) * PI/180.
+	dlphi(3) = smixgrd%gphi(kji+2*nn_rhox*klon,kjj+2*nn_rhoy*klat) * PI/180.
+	dlk(3)   = (2*dray) / (1 + (SIN(dl_lat0)*SIN(dlphi(3))) + (COS(dl_lat0)*COS(dlphi(3))*COS(dllam(3) - dl_long0)))
+	!
+	dllam(4) = smixgrd%glam(kji+3*nn_rhox*klon,kjj+3*nn_rhoy*klat) * PI/180.
+	dlphi(4) = smixgrd%gphi(kji+3*nn_rhox*klon,kjj+3*nn_rhoy*klat) * PI/180.
+	dlk(4)   = (2*dray) / (1 + (SIN(dl_lat0)*SIN(dlphi(4))) + (COS(dl_lat0)*COS(dlphi(4))*COS(dllam(4) - dl_long0)))
+	!	
+	dlx(1) = dlk(1) * COS(dlphi(1)) * SIN(dllam(1) - dl_long0)
+	dly(1) = dlk(1) * ((COS(dl_lat0) * SIN(dlphi(1))) - (SIN(dl_lat0) * COS(dlphi(1)) * COS(dllam(1) - dl_long0)))
+    !
+	dlx(2) = dlk(2) * COS(dlphi(2)) * SIN(dllam(2) - dl_long0)
+	dly(2) = dlk(2) * ((COS(dl_lat0) * SIN(dlphi(2))) - (SIN(dl_lat0) * COS(dlphi(2)) * COS(dllam(2) - dl_long0)))
+    !
+	dlx(3) = dlk(3) * COS(dlphi(3)) * SIN(dllam(3) - dl_long0)
+	dly(3) = dlk(3) * ((COS(dl_lat0) * SIN(dlphi(3))) - (SIN(dl_lat0) * COS(dlphi(3)) * COS(dllam(3) - dl_long0)))
+    !
+	dlx(4) = dlk(4) * COS(dlphi(4)) * SIN(dllam(4) - dl_long0)
+	dly(4) = dlk(4) * ((COS(dl_lat0) * SIN(dlphi(4))) - (SIN(dl_lat0) * COS(dlphi(4)) * COS(dllam(4) - dl_long0)))
+    ! 
+	dmixlam(1) = smixgrd%glam(kji,kjj)         
+	dmixlam(2) = smixgrd%glam(kji+1*nn_rhox*klon,kjj+1*nn_rhoy*klat) 
+    dmixlam(3) = smixgrd%glam(kji+2*nn_rhox*klon,kjj+2*nn_rhoy*klat) 
+    dmixlam(4) = smixgrd%glam(kji+3*nn_rhox*klon,kjj+3*nn_rhoy*klat)
+	!
+	dmixphi(1) = smixgrd%gphi(kji,kjj)       
+	dmixphi(2) = smixgrd%gphi(kji+1*nn_rhox*klon,kjj+1*nn_rhoy*klat) 
+    dmixphi(3) = smixgrd%gphi(kji+2*nn_rhox*klon,kjj+2*nn_rhoy*klat) 
+    dmixphi(4) = smixgrd%gphi(kji+3*nn_rhox*klon,kjj+3*nn_rhoy*klat)
+	!
+	smixgrd%glam(kji,kjj)                               = dlx(1)
+	smixgrd%glam(kji+1*nn_rhox*klon,kjj+1*nn_rhoy*klat) = dlx(2)
+	smixgrd%glam(kji+2*nn_rhox*klon,kjj+2*nn_rhoy*klat) = dlx(3)
+	smixgrd%glam(kji+3*nn_rhox*klon,kjj+3*nn_rhoy*klat) = dlx(4)
+	!
+	smixgrd%gphi(kji,kjj)                               = dly(1)
+	smixgrd%gphi(kji+1*nn_rhox*klon,kjj+1*nn_rhoy*klat) = dly(2)
+    smixgrd%gphi(kji+2*nn_rhox*klon,kjj+2*nn_rhoy*klat) = dly(3)
+    smixgrd%gphi(kji+3*nn_rhox*klon,kjj+3*nn_rhoy*klat) = dly(4)
+	!
+  END SUBROUTINE stereo_projection
+  ! 
+  !
+  !
+  !********************************************************
+  !          SUBROUTINE stereo_projection_inv    	    *
+  !									        			*
+  !												        *
+  !		            CALLED from here	                *
+  !********************************************************
+  SUBROUTINE stereo_projection_inv(kji,kjj,kjk,knorth_pole,kway)
+    !
+    INTEGER,INTENT(IN) :: kji,kjj,kjk
+	LOGICAL,INTENT(IN) :: knorth_pole
+	INTEGER,INTENT(IN) :: kway
+	INTEGER :: klon, klat
+	REAL*8,DIMENSION(5) :: dlx, dly
+	REAL*8,DIMENSION(5)  :: dllam, dlphi
+    REAL*8,DIMENSION(5)  :: dlro, dlc
+	REAL*8 :: dl_long0, dl_lat0
+	!	
+    dl_lat0 = dlat0 * PI/180.
+    dl_long0 = dlong0 * PI/180.
+    !
+ 	IF(kway.EQ.1)THEN
+	  klon = 1
+	  klat = 0
+	ELSEIF(kway.EQ.2) THEN
+	  klon = 0
+	  klat = 1
+	ENDIF
+	!
+	!
+	dlx(1) = smixgrd%glam(kji,kjj)
+	dlx(2) = smixgrd%glam(kji+1*nn_rhox*klon,kjj+1*nn_rhoy*klat)
+	dlx(3) = smixgrd%glam(kji+2*nn_rhox*klon,kjj+2*nn_rhoy*klat)
+	dlx(4) = smixgrd%glam(kji+3*nn_rhox*klon,kjj+3*nn_rhoy*klat)	
+	dlx(5) = smixgrd%glam(kji+(nn_rhox+kjk)*klon,kjj+(nn_rhoy+kjk)*klat) 
+	!
+	dly(1) = smixgrd%gphi(kji,kjj)
+	dly(2) = smixgrd%gphi(kji+1*nn_rhox*klon,kjj+1*nn_rhoy*klat)
+	dly(3) = smixgrd%gphi(kji+2*nn_rhox*klon,kjj+2*nn_rhoy*klat)
+	dly(4) = smixgrd%gphi(kji+3*nn_rhox*klon,kjj+3*nn_rhoy*klat)	
+	dly(5) = smixgrd%gphi(kji+(nn_rhox+kjk)*klon,kjj+(nn_rhoy+kjk)*klat) 	
+	!
+	dlro(1) = SQRT(dlx(1)*dlx(1) + dly(1)*dly(1))
+	dlro(2) = SQRT(dlx(2)*dlx(2) + dly(2)*dly(2))
+	dlro(3) = SQRT(dlx(3)*dlx(3) + dly(3)*dly(3))
+	dlro(4) = SQRT(dlx(4)*dlx(4) + dly(4)*dly(4))
+	dlro(5) = SQRT(dlx(5)*dlx(5) + dly(5)*dly(5))
+	!
+	dlc(1) = 2*ATAN(dlro(1)/(2*dray))
+	dlc(2) = 2*ATAN(dlro(2)/(2*dray))
+	dlc(3) = 2*ATAN(dlro(3)/(2*dray))
+	dlc(4) = 2*ATAN(dlro(4)/(2*dray))
+	dlc(5) = 2*ATAN(dlro(5)/(2*dray))
+	!
+	dlphi(1) =  ASIN(COS(dlc(1))*SIN(dl_lat0) + (dly(1)*SIN(dlc(1))*COS(dl_lat0) / dlro(1)))
+	dlphi(2) =  ASIN(COS(dlc(2))*SIN(dl_lat0) + (dly(2)*SIN(dlc(2))*COS(dl_lat0) / dlro(2)))
+	dlphi(3) =  ASIN(COS(dlc(3))*SIN(dl_lat0) + (dly(3)*SIN(dlc(3))*COS(dl_lat0) / dlro(3)))
+	dlphi(4) =  ASIN(COS(dlc(4))*SIN(dl_lat0) + (dly(4)*SIN(dlc(4))*COS(dl_lat0) / dlro(4)))
+	dlphi(5) =  ASIN(COS(dlc(5))*SIN(dl_lat0) + (dly(5)*SIN(dlc(5))*COS(dl_lat0) / dlro(5)))
+    !	
+	dlphi(:) = dlphi(:) * 180./PI
+    !
+	dllam(1) = dl_long0 + ATAN(dlx(1)*SIN(dlc(1) / ((dlro(1)*COS(dl_lat0)*COS(dlc(1)))-(dly(1)*SIN(dl_lat0)*SIN(dlc(1))))))
+	dllam(2) = dl_long0 + ATAN(dlx(2)*SIN(dlc(2) / ((dlro(2)*COS(dl_lat0)*COS(dlc(2)))-(dly(2)*SIN(dl_lat0)*SIN(dlc(2))))))
+	dllam(3) = dl_long0 + ATAN(dlx(3)*SIN(dlc(3) / ((dlro(3)*COS(dl_lat0)*COS(dlc(3)))-(dly(3)*SIN(dl_lat0)*SIN(dlc(3))))))
+	dllam(4) = dl_long0 + ATAN(dlx(4)*SIN(dlc(4) / ((dlro(4)*COS(dl_lat0)*COS(dlc(4)))-(dly(4)*SIN(dl_lat0)*SIN(dlc(4))))))
+	dllam(5) = dl_long0 + ATAN(dlx(5)*SIN(dlc(5) / ((dlro(5)*COS(dl_lat0)*COS(dlc(5)))-(dly(5)*SIN(dl_lat0)*SIN(dlc(5))))))
+    !
+	dllam(1) = dllam(1) * 180./PI
+	dllam(2) = dllam(2) * 180./PI 
+	dllam(3) = dllam(3) * 180./PI 
+	dllam(4) = dllam(4) * 180./PI 
+    !
+	dllam(5) = dllam(5) * 180./PI 
+	!
+	IF(kway.EQ.1)THEN		
+	  IF(idisc.EQ.1) THEN
+		dllam(5) = dllam(5) + 180.
+	  ELSEIF(idisc.EQ.2) THEN
+		dllam(5) = dllam(5) - 180.
+	  ELSEIF(idisc.EQ.3) THEN
+		 dllam(5) = dllam(5) - 180.
+	  ELSE
+		dllam(5) = dllam(5)  
+	  ENDIF
+	  !
+	ELSEIF(kway.EQ.2)THEN
+	  IF(smixgrd%glam(kji,kjj+1*nn_rhoy).GT.0.AND.smixgrd%glam(kji,kjj+2*nn_rhoy).GT.0)THEN
+	    IF(dllam(5).LT.0.)THEN
+	      dllam(5) = dllam(5) + 180
+		ENDIF
+	  ELSEIF(smixgrd%glam(kji,kjj+1*nn_rhoy).LT.0.AND.smixgrd%glam(kji,kjj+2*nn_rhoy).LT.0)THEN
+	    IF(dllam(5).GT.0.)THEN
+		  dllam(5) = dllam(5) - 180
+	    ENDIF
+	  ELSEIF(smixgrd%glam(kji,kjj+1*nn_rhoy)*smixgrd%glam(kji,kjj+2*nn_rhoy).LT.0)THEN
+	    IF(dllam(5).LT.0.)THEN
+	      dllam(5) = dllam(5) + 180
+	    ELSEIF(dllam(5).GT.0.)THEN
+	      dllam(5) = dllam(5) - 180
+	    ENDIF
+	  ENDIF
+	ENDIF
+	!
+	smixgrd%glam(kji,kjj)                                       = dmixlam(1)
+	smixgrd%glam(kji+1*nn_rhox*klon,kjj+1*nn_rhoy*klat)         = dmixlam(2)
+    smixgrd%glam(kji+2*nn_rhox*klon,kjj+2*nn_rhoy*klat)         = dmixlam(3)
+    smixgrd%glam(kji+3*nn_rhox*klon,kjj+3*nn_rhoy*klat)         = dmixlam(4)
+	!
+    smixgrd%glam(kji+(nn_rhox+kjk)*klon,kjj+(nn_rhoy+kjk)*klat) = dllam(5)
+	!
+	smixgrd%gphi(kji,kjj)                                       = dmixphi(1)
+	smixgrd%gphi(kji+1*nn_rhox*klon,kjj+1*nn_rhoy*klat)         = dmixphi(2)
+    smixgrd%gphi(kji+2*nn_rhox*klon,kjj+2*nn_rhoy*klat)         = dmixphi(3)
+    smixgrd%gphi(kji+3*nn_rhox*klon,kjj+3*nn_rhoy*klat)         = dmixphi(4)
+	!
+    smixgrd%gphi(kji+(nn_rhox+kjk)*klon,kjj+(nn_rhoy+kjk)*klat) = dlphi(5)
+	!
+  END SUBROUTINE stereo_projection_inv
+  !
+  !
+  !
+END MODULE projection
Index: trunk/NEMOGCM/TOOLS/GRIDGEN/src/readwrite.f90
===================================================================
--- trunk/NEMOGCM/TOOLS/GRIDGEN/src/readwrite.f90	(revision 2528)
+++ trunk/NEMOGCM/TOOLS/GRIDGEN/src/readwrite.f90	(revision 2528)
@@ -0,0 +1,182 @@
+MODULE readwrite
+  !
+  USE types
+  !
+  IMPLICIT NONE
+  !
+CONTAINS
+  !       
+  !*****************************************************
+  !   function Read_Coordinates(name,Grid)
+  !*****************************************************
+  INTEGER FUNCTION read_coordinates(name,Grid)
+    !
+    USE io_netcdf
+    !         
+    CHARACTER(*) name
+    TYPE(coordinates) :: Grid
+    !      
+    CALL Read_Ncdf_var('glamt',name,Grid%glamt)
+    CALL Read_Ncdf_var('glamu',name,Grid%glamu)
+    CALL Read_Ncdf_var('glamv',name,Grid%glamv)
+    CALL Read_Ncdf_var('glamf',name,Grid%glamf)
+    CALL Read_Ncdf_var('gphit',name,Grid%gphit)
+    CALL Read_Ncdf_var('gphiu',name,Grid%gphiu)
+    CALL Read_Ncdf_var('gphiv',name,Grid%gphiv)
+    CALL Read_Ncdf_var('gphif',name,Grid%gphif)
+    CALL Read_Ncdf_var('e1t',name,Grid%e1t)
+    CALL Read_Ncdf_var('e1u',name,Grid%e1u)
+    CALL Read_Ncdf_var('e1v',name,Grid%e1v)
+    CALL Read_Ncdf_var('e1f',name,Grid%e1f)
+    CALL Read_Ncdf_var('e2t',name,Grid%e2t)
+    CALL Read_Ncdf_var('e2u',name,Grid%e2u)
+    CALL Read_Ncdf_var('e2v',name,Grid%e2v)
+    CALL Read_Ncdf_var('e2f',name,Grid%e2f)
+    CALL Read_Ncdf_var('nav_lon',name,Grid%nav_lon)
+    CALL Read_Ncdf_var('nav_lat',name,Grid%nav_lat)       
+    !            
+    WRITE(*,*) ' '
+    WRITE(*,*) '*** Reading coordinates file: ',name
+    WRITE(*,*) ' '
+    !      
+    read_coordinates = 1
+    !      
+  END FUNCTION read_coordinates
+  !
+  !
+  !
+  !*****************************************************
+  !   function Write_Coordinates(name,Grid)
+  !*****************************************************
+  INTEGER FUNCTION write_coordinates(name,Grid,kxfine,kyfine)
+    !
+    USE io_netcdf
+	!
+    CHARACTER(*) name
+    TYPE(coordinates) :: Grid
+    INTEGER :: status,ncid,z
+    REAL*8,DIMENSION(:),POINTER :: tabtemp
+    INTEGER,DIMENSION(:),POINTER :: tabint
+    CHARACTER(len=20),DIMENSION(4) :: dimnames
+	INTEGER :: kxfine, kyfine
+    !
+    status = nf90_create(name,NF90_WRITE,ncid)
+    status = nf90_close(ncid)
+    !           
+	CALL Write_Ncdf_dim('x',name,nxfine)
+    CALL Write_Ncdf_dim('y',name,nyfine)
+    IF(.NOT. ln_iom_activated) CALL Write_Ncdf_dim('z',name,1)
+    CALL Write_Ncdf_dim('time',name,0)
+    !      
+    dimnames(1)='x'
+    dimnames(2)='y'
+    CALL Write_Ncdf_var('nav_lon',dimnames(1:2),name,Grid%nav_lon,'float')      
+    CALL Write_Ncdf_var('nav_lat',dimnames(1:2),name,Grid%nav_lat,'float')
+    !
+    IF(.NOT. ln_iom_activated) THEN
+       ! copy nav_lev variable -> IOIPSL
+       CALL Read_Ncdf_dim('z',cn_parent_coordinate_file,z)
+       ALLOCATE(tabtemp(z))
+       CALL Read_Ncdf_var('nav_lev',TRIM(cn_parent_coordinate_file),tabtemp)
+       CALL Write_Ncdf_var('nav_lev','z',name,tabtemp,'float')           
+       DEALLOCATE(tabtemp)
+    ENDIF
+    !
+    CALL Read_Ncdf_var('time',TRIM(cn_parent_coordinate_file),tabtemp)
+    CALL Write_Ncdf_var('time','time',name,tabtemp,'float')           
+    DEALLOCATE(tabtemp)      
+    CALL Read_Ncdf_var('time_steps',TRIM(cn_parent_coordinate_file),tabint)
+    CALL Write_Ncdf_var('time_steps','time',name,tabint) 
+    !      
+    dimnames(1)='x'
+    dimnames(2)='y'
+    IF(ln_iom_activated) THEN
+       dimnames(3)='time'
+    ELSE
+       dimnames(3)='z'
+       dimnames(4)='time'
+    ENDIF
+
+    CALL Write_Ncdf_var('glamt',dimnames,name,Grid%glamt,3,'double')
+    CALL Write_Ncdf_var('glamu',dimnames,name,Grid%glamu,3,'double')
+    CALL Write_Ncdf_var('glamv',dimnames,name,Grid%glamv,3,'double')
+    CALL Write_Ncdf_var('glamf',dimnames,name,Grid%glamf,3,'double')
+    CALL Write_Ncdf_var('gphit',dimnames,name,Grid%gphit,3,'double')
+    CALL Write_Ncdf_var('gphiu',dimnames,name,Grid%gphiu,3,'double')
+    CALL Write_Ncdf_var('gphiv',dimnames,name,Grid%gphiv,3,'double')
+    CALL Write_Ncdf_var('gphif',dimnames,name,Grid%gphif,3,'double')      
+    CALL Write_Ncdf_var('e1t',dimnames,name,Grid%e1t,3,'double')      
+    CALL Write_Ncdf_var('e1u',dimnames,name,Grid%e1u,3,'double')     
+    CALL Write_Ncdf_var('e1v',dimnames,name,Grid%e1v,3,'double')      
+    CALL Write_Ncdf_var('e1f',dimnames,name,Grid%e1f,3,'double')
+    CALL Write_Ncdf_var('e2t',dimnames,name,Grid%e2t,3,'double')
+    CALL Write_Ncdf_var('e2u',dimnames,name,Grid%e2u,3,'double')
+    CALL Write_Ncdf_var('e2v',dimnames,name,Grid%e2v,3,'double')
+    CALL Write_Ncdf_var('e2f',dimnames,name,Grid%e2f,3,'double')
+    !      
+    CALL Copy_Ncdf_att('nav_lon',TRIM(cn_parent_coordinate_file),name,&
+         MINVAL(Grid%nav_lon),MAXVAL(Grid%nav_lon))
+    CALL Copy_Ncdf_att('nav_lat',TRIM(cn_parent_coordinate_file),name,&
+         MINVAL(Grid%nav_lat),MAXVAL(Grid%nav_lat))
+    CALL Copy_Ncdf_att('nav_lev',TRIM(cn_parent_coordinate_file),name)
+    CALL Copy_Ncdf_att('time',TRIM(cn_parent_coordinate_file),name)
+    CALL Copy_Ncdf_att('time_steps',TRIM(cn_parent_coordinate_file),name)
+    CALL Copy_Ncdf_att('glamt',TRIM(cn_parent_coordinate_file),name)
+    CALL Copy_Ncdf_att('glamu',TRIM(cn_parent_coordinate_file),name)
+    CALL Copy_Ncdf_att('glamv',TRIM(cn_parent_coordinate_file),name)
+    CALL Copy_Ncdf_att('glamf',TRIM(cn_parent_coordinate_file),name)
+    CALL Copy_Ncdf_att('gphit',TRIM(cn_parent_coordinate_file),name)
+    CALL Copy_Ncdf_att('gphiu',TRIM(cn_parent_coordinate_file),name)
+    CALL Copy_Ncdf_att('gphiv',TRIM(cn_parent_coordinate_file),name)
+    CALL Copy_Ncdf_att('gphif',TRIM(cn_parent_coordinate_file),name)
+    CALL Copy_Ncdf_att('e1t',TRIM(cn_parent_coordinate_file),name)
+    CALL Copy_Ncdf_att('e1u',TRIM(cn_parent_coordinate_file),name)
+    CALL Copy_Ncdf_att('e1v',TRIM(cn_parent_coordinate_file),name)
+    CALL Copy_Ncdf_att('e1f',TRIM(cn_parent_coordinate_file),name)
+    CALL Copy_Ncdf_att('e2t',TRIM(cn_parent_coordinate_file),name)
+    CALL Copy_Ncdf_att('e2u',TRIM(cn_parent_coordinate_file),name)
+    CALL Copy_Ncdf_att('e2v',TRIM(cn_parent_coordinate_file),name)
+    CALL Copy_Ncdf_att('e2f',TRIM(cn_parent_coordinate_file),name)            
+    !
+    WRITE(*,*) ' '
+    WRITE(*,*) 'Writing coordinates file: ',name
+    IF(.NOT. ln_iom_activated) WRITE(*,*) 'IOISPL format'
+    IF(ln_iom_activated) WRITE(*,*) 'IOM format'      
+    WRITE(*,*) ' '
+    !
+    write_coordinates = 1
+    !      
+  END FUNCTION write_coordinates
+  !
+  !
+  !
+  !*****************************************************
+  !   function set_child_name(Parentname,Childname)
+  !*****************************************************
+  SUBROUTINE set_child_name(Parentname,Childname)
+    !
+    CHARACTER(*),INTENT(in) :: Parentname
+    CHARACTER(*),INTENT(out) :: Childname
+    CHARACTER(2) :: prefix
+    INTEGER :: pos
+    !   
+    pos  = INDEX(TRIM(Parentname),'/',back=.TRUE.)
+    !
+    prefix=Parentname(pos+1:pos+2)
+    IF (prefix == '1_') THEN
+       Childname = '2_'//Parentname(pos+3:LEN(Parentname)) 
+    ELSEIF (prefix == '2_') THEN
+       Childname = '3_'//Parentname(pos+3:LEN(Parentname)) 
+    ELSEIF (prefix == '3_') THEN
+       Childname = '4_'//Parentname(pos+3:LEN(Parentname)) 
+    ELSEIF (prefix == '4_') THEN
+       Childname = '5_'//Parentname(pos+3:LEN(Parentname)) 
+    ELSE
+       Childname = '1_'//Parentname(pos+1:LEN(Parentname)) 
+    ENDIF
+    !   
+  END SUBROUTINE set_child_name
+  !
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!             
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+END MODULE readwrite
